#!/bin/bash
# This plug-in counts tickets with open status
# and medium priority,   It provides a count, and 
# nothing else (for graphing purposes).No details
# of the tickets are provided. 

# the user ID executing the script must have write rights
# in the current folder

# You need the text http browser, "lynx" installed. 
# You may need to specify a domain in the username.
# If so, use double back slashes. .
#  Ex:  USER=mydomain\\username

USER=username
PASS=password
STATE_OK=0
STATE_WARNING=1
STATE_CRITICAL=2
STATE_UNKNOWN=3
STATE_DEPENDENT=4

cd /usr/local/nagios/libexec


# this check needs PDA session info
source ./SD-PDA-session.txt


#if [ -z $1 ]
#then
#	echo "Usage: check-sdtrends.sh groupname \ anything below critical is a warning level"
#	exitstatus=$STATE_UNKNOWN
#	exit $exitstatus
#fi

if [ -z "$SID" ] ; then
        # we got an empty string
	echo "UNKNOWN: - Session info missing"
        exitstatus=$STATE_UNKNOWN
	exit $exitstatus;
fi
TMP="output-$1-trends.html"


wget -T 6 -t3 -q -O $TMP --user=$USER --password=$PASS http://$server/CAisd/$pdmweb.exe?SID=$SID+FID=$FID+OP=SEARCH+QBE.EQ.status=OP+QBE.EQ.priority=3+FACTORY=cr+QBE.IN.group.last_name=$1%25

# check that wget worked.  Error levels are:
#1   Generic error code.
#2   Parse error—for instance, when parsing command-line options, the ‘.wgetrc’ or ‘.netrc’...
#3   File I/O error.
#4   Network failure.
#5   SSL verification failure.
#6   Username/password authentication failure.
#7   Protocol errors.
#8   Server issued an error response. 


STATUS=$?
if [ "$STATUS" -eq 6 ] ; then
	echo "UNKNOWN: - Authentication not accepted"
        exitstatus=$STATE_UNKNOWN
	exit $exitstatus;
fi

if [ "$STATUS" -ne 0 ] ; then
	echo "UNKNOWN: - SD Engine down? ($STATUS)"
        exitstatus=$STATE_UNKNOWN
	exit $exitstatus;
fi


#Is it a redirect/bad session?  1=yes 0=no
output=`grep -a OnLoad\=\'do_submit $TMP|wc -l`
if [ "$output" -eq 1 ]; then
        echo "UNKNOWN: - Redirect Received"
	rm $TMP
        exitstatus=$STATE_UNKNOWN
        exit $exitstatus;
fi
output=`grep -a noconnect $TMP|wc -l`
if [ "$output" -eq 1 ]; then
        echo "UNKNOWN: - No valid connection to server"
	rm $TMP
        exitstatus=$STATE_UNKNOWN
        exit $exitstatus;
fi

output=`grep -a USERNAME $TMP|grep User\ Name|wc -l`
if [ "$output" -gt 0 ]; then
        echo "UNKNOWN: - Login prompt received."
	rm $TMP
        exitstatus=$STATE_UNKNOWN
        exit $exitstatus;
fi

output=`grep Authentication\ failure $TMP -a|wc -l`
if [ "$output" -gt 0 ]; then
        echo "UNKNOWN: - Login prompt received."
	rm $TMP
        exitstatus=$STATE_UNKNOWN
        exit $exitstatus;
fi

output=`grep Parse\ error $TMP -a|wc -l`
if [ "$output" -gt 0 ]; then
        echo "UNKNOWN: - Parse Error received."
	rm $TMP
        exitstatus=$STATE_UNKNOWN
        exit $exitstatus;
fi

# find the line with query matches count, and cut, and remove
# non digits
open=`grep -a title2 $TMP| cut -d ">" -f2| sed 's/[^0-9]*//g'`
exitstatus=$STATE_OK

if [ -z "$open" ] ; then 
        message="OK: Empty box. 0 tickets for $1|open=0\n";
        exitstatus=$STATE_OK


elif  [ "$open" -eq "0" ] ;  then
	message="OK: $1 has 0 tickets with open status.|open=$open\n"
	exitstatus=$STATE_OK

else  message="OK:  $open open ticket(s) for $1 detected|open=$open\n" 
fi

echo -e "$message"
exit $exitstatus;
